        list      p=12f629            ;  
                                      ;  PIC12F675
        #include <p12f629.inc>

        ; -  ,    - 4
        __CONFIG   _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT

TX_BUF          EQU     0x20 ;  
CNTR            EQU     0x21 ; 
DL_CNT          EQU     0x22 ;  
LCD1            EQU     0x23 ;   DD3
LCD2            EQU     0x24 ;   DD2
LCD3            EQU     0x25 ;   DD1 (  )
NUM1            EQU     0x26 ;   
NUM2            EQU     0x27 ;
NUM3            EQU     0x28 ;
NUM4            EQU     0x29 ;   
KF              EQU     0x2a ;   ('00' = 0 '01' = 10 ' '10' = 100)
ZNAK            EQU     0x2b ;   ('1' = minus)
TEMP            EQU     0x2c ;  
BYTE1           EQU     0x2d ;    
BYTE2           EQU     0x2e ;    
                
		ORG     0x000              ;  
                goto    main                
                ORG     0x010		   ;   
main
                call    0x3FF              ;    (DS41190A, page 16)
                bsf     STATUS, RP0        ;  1
                movwf   OSCCAL             ;  
                bcf     STATUS, RP0        ;  0
                bcf     INTCON, GIE        ;  

                ; 
                clrf    GPIO
                movlw   0x07
                movwf   CMCON
                bsf     STATUS, RP0
                movlw   b'00001001'        ;  
                movwf   TRISIO
                bcf     STATUS, RP0

main_loop                                  ;  
                btfsc   GPIO, 0            ;    COM  ()
                goto    main_loop

                call    STROB              ;    
                                           ; 

                clrf    CNTR               ;   
load_lcd1                                  ;   
                btfsc   GPIO, 3            ;   
                goto    set_11
                bcf     STATUS, C          ;     C
                goto    next_11
set_11
                bsf     STATUS, C
next_11
                rrf     LCD1, F            ;    
                call    CLOCK              ;     
                incf    CNTR, F
                btfss   CNTR, 3            ;    
                goto    load_lcd1          ;   

                clrf    CNTR               ;    DD2
load_lcd2
                btfsc   GPIO, 3
                goto    set_21
                bcf     STATUS, C
                goto    next_21
set_21
                bsf     STATUS, C
next_21
                rrf     LCD2, F
                call    CLOCK
                incf    CNTR, F
                btfss   CNTR, 3
                goto    load_lcd2

                clrf    CNTR               ;    DD1
load_lcd3
                btfsc   GPIO, 3
                goto    set_31
                bcf     STATUS, C
                goto    next_31
set_31
                bsf     STATUS, C
next_31
                rrf     LCD3, F
                call    CLOCK
                incf    CNTR, F
                btfss   CNTR, 3
                goto    load_lcd3

                ;   ,   
                clrf    NUM1
                clrf    NUM2
                clrf    NUM3
                clrf    NUM4

                ;   (BP = 1)
                btfss   LCD1, 0
                goto    tst_cms            ;    
                                           ;    
                ;  
                comf    LCD1, F
                comf    LCD2, F
                comf    LCD3, F
                goto    next_inv

tst_cms
                ;  
                clrf    KF
                btfsc   LCD3, 4
                bsf     KF, 1
                btfsc   LCD2, 4
                bsf     KF, 0

next_inv
                ; 
                clrf    ZNAK
                btfsc   LCD2, 0
                bsf     ZNAK, 0

                ;   (AB4)
                clrf    NUM1
                btfsc   LCD3, 0
                bsf     NUM1, 0

                ;   
                bcf     LCD1, 4
                bcf     LCD2, 4
                bcf     LCD3, 4

                ;  AB4, POL, BP
                bcf     LCD1, 0
                bcf     LCD2, 0
                bcf     LCD3, 0

                ;   
                movf    LCD1, W
                call    CONV_IMAGE
                movwf   NUM2

                movf    LCD2, W
                call    CONV_IMAGE
                movwf   NUM3

                movf    LCD3, W
                call    CONV_IMAGE
                movwf   NUM4

                ;     
                ;
                ;      BYTE1             BYTE2
                ; 7    4  3    0     7    4  3 2 1 0
                ;[ NUM1 ][ NUM3 ]   [ NUM4 ][       ]
                ;                           N Z K K
                ;                           U N F F
                ;                           M A 1 1
                ;                           1 K 0 0
                ;                               0

                clrf    BYTE1
                clrf    BYTE2
                swapf   NUM2, W
                movwf   BYTE1           ;  NUM2

                movf    NUM3, W
                iorwf   BYTE1, F        ;  NUM3

                swapf   NUM4, W         ;  NUM4
                movwf   BYTE2

                ;  ,   
                btfsc   NUM1, 0
                bsf     BYTE2, 3
                btfsc   ZNAK, 0
                bsf     BYTE2, 2
                btfsc   KF, 1
                bsf     BYTE2, 1
                btfsc   KF, 0
                bsf     BYTE2, 0

                ;  
                movf    BYTE1, W
                movwf   TX_BUF
                call    TRANSMIT_BYTE

                ;   
                call    DELAY_LONG
                call    DELAY_LONG
                call    DELAY_LONG

                ;  
                movf    BYTE2, W
                movwf   TX_BUF
                call    TRANSMIT_BYTE

                ;  
                clrf    GPIO
                goto    main_loop

;       
;    W    
CONV_IMAGE
                movwf   TEMP
                ;         abcdefg
                xorlw   b'11101100'
                btfsc   STATUS, Z
                retlw   0h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'01100000'
                btfsc   STATUS, Z
                retlw   1h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'11001010'
                btfsc   STATUS, Z
                retlw   2h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'11100010'
                btfsc   STATUS, Z
                retlw   3h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'01100110'
                btfsc   STATUS, Z
                retlw   4h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'10100110'
                btfsc   STATUS, Z
                retlw   5h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'10101110'
                btfsc   STATUS, Z
                retlw   6h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'11100000'
                btfsc   STATUS, Z
                retlw   7h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'11101110'
                btfsc   STATUS, Z
                retlw   8h

                movf    TEMP, W
                ;         abcdefg
                xorlw   b'11100110'
                btfsc   STATUS, Z
                retlw   9h
                ;     
                retlw   0fh

;    
CLOCK
                ;         ||RCDTTR
                ;         ||DLAXXX
                ;         || KT12
                ;         ||  A
                movlw   b'00110010'
                movwf   GPIO
                call    DELAY_SHORT
                movlw   b'00100010'
                movwf   GPIO
                call    DELAY_SHORT
                movlw   b'00110010'
                movwf   GPIO
                call    DELAY_SHORT
                return

;    
STROB
                ;         ||RCDTTR
                ;         ||DLAXXX
                ;         || KT12
                ;         ||  A
                movlw   b'00110010'
                movwf   GPIO
                call    DELAY_SHORT
                movlw   b'00010010'
                movwf   GPIO
                call    DELAY_SHORT
                movlw   b'00110010'
                movwf   GPIO
                call    DELAY_SHORT
                return

; 
TRANSMIT_BYTE
                ;  
                call    TRANSMIT_0
                call    DELAY_TRANSMIT
                call    DELAY_SHORT
                clrf    CNTR            ;  
tx_loop
                rrf     TX_BUF, F       ; 
                btfsc   STATUS, C       ;   
                goto    bit_1
                call    TRANSMIT_0
                goto    next_2
bit_1
                call    TRANSMIT_1
next_2
                incf    CNTR, F
                call    DELAY_TRANSMIT  ;   
                btfss   CNTR, 3         ;   
                goto    tx_loop
                ;  
                call    TRANSMIT_1
                call    DELAY_TRANSMIT
                call    DELAY_LONG
                return

;    
DELAY_TRANSMIT
                ;movlw   0x85           ;2400
                movlw   0x3e            ;4800
                ;movlw   0x1b           ;9600

                movwf   DL_CNT          ; 
dl_1
                decfsz  DL_CNT, F
                goto    dl_1
                return

; 
DELAY_SHORT
                movlw   0x09
                movwf   DL_CNT
dl_2
                decfsz  DL_CNT, F
                goto    dl_2
                return

;   
DELAY_LONG
                movlw   0xff
                movwf   DL_CNT
dl_3
                decfsz  DL_CNT, F
                goto    dl_3
                return

; 0
TRANSMIT_0
                movlw   0x04
                movwf   GPIO
                return

; 1
TRANSMIT_1
                movlw   0x02
                movwf   GPIO
                return

                END

